{************************************}
{* Main unit for SQLite application *}
{************************************}

unit sqlite_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, SQLite3Conn, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls;

type
  {**********}
  { TfSQLite }
  {**********}
  TfSQLite = class(TForm)
    StaticText1: TStaticText;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    edCities: TEdit;
    edMess: TEdit;
    btConnect: TButton;
    btQuery: TButton;
    btExit: TButton;
    dbSQLiteConnection: TSQLite3Connection;
    dbSQLTransaction: TSQLTransaction;
    dbSQLQuery: TSQLQuery;
    procedure btConnectClick(Sender: TObject);
    procedure btQueryClick(Sender: TObject);
    procedure btExitClick(Sender: TObject);
  end;

var
  fSQLite: TfSQLite;

implementation

{$R *.lfm}

{**********}
{ TfSQLite }
{**********}

{ Button "Connect": Connect to "world" database }

procedure TfSQLite.btConnectClick(Sender: TObject);

begin
  if dbSQLiteConnection.Connected then                                         // close (open) database connection
    dbSQLiteConnection.Close;
  // Set the connection parameters.
  dbSQLiteConnection.UserName := '';
  dbSQLiteConnection.Password := '';
  dbSQLiteConnection.DatabaseName := 'C:\Programs\SQLite\world.db';
  // Connect to the world database
  try
    dbSQLiteConnection.Open;
    edMess.Text := 'Connection to SQLite database "world" = OK!';
  except
    on E: ESQLDatabaseError do
      edMess.Text := E.Message;
  end;
end;

{ Button "Query": Read number of cities from "city" table }

procedure TfSQLite.btQueryClick(Sender: TObject);

var
  Count: Integer;

begin
  if dbSQLiteConnection.Connected then begin
    // Query the database
    dbSQLQuery.SQL.Text := 'SELECT count(*) FROM city';
    try
      dbSQLQuery.Open;
      if dbSQLQuery.EOF then
        Count := 0
      else
        Count := dbSQLQuery.Fields[0].AsInteger;
      dbSQLQuery.Close;
      // Display the query result
      edCities.Text := IntToStr(Count);
    except
      on E: ESQLDatabaseError do
        edMess.Text := E.Message;
    end;
  end;
end;

{ Button "Exit": Close database connection and exit application }

procedure TfSQLite.btExitClick(Sender: TObject);

begin
  if dbSQLiteConnection.Connected then                                         // close (open) database connection
    dbSQLiteConnection.Close;
  Close;
end;

end.

